//---------------------------------------------------------------------------
// :      Zoom - 2
//
// Copyright:   "Nota-PI group" 2000.
//
//---------------------------------------------------------------------------
// :      query_constr.js
// :    
// :        JavaScript
//
// :     
//
// :        ,  
// :  08.02.2005 - ...
//---------------------------------------------------------------------------
<!--

var c_sDelimiter1 = '@'
var c_sDelimiter2 = '#'

var c_sRangeFldID      = "Range"
var c_sFuncFldID       = "func"
var c_sDateChk1FldID   = "dateck1"
var c_sDateChk2FldID   = "dateck2"
var c_sDateMinInputID  = "min_date"
var c_sDateMaxInputID  = "max_date"
var c_sDateBaseFieldID = "$[MainDate]"
var c_sCodeFld   = "code"
var c_sPhoneFld  = "phone"
var c_sPersonFld = "person"
var c_sFamilyFld = "family"
var c_sNameAndPatronymicFld = "name_and_patronymic"
var c_sFamilyMultiFld       = "family_multi"

var c_sFuncValWord = 1
var c_sFuncValDoc  = 2

var g_sConstrStateManual = 0 //    ( )
var g_sConstrStateConstr = 1 //  
var g_sConstrStateHidden = 2 //     .

var g_BaseListChanged = false;
var anm = 0;
function pushElement(p_aArray, newVal) {
	p_aArray[p_aArray.length] = newVal

	return p_aArray
}

var g_bAspnetForm = false;

//  ,   .      
// form_fields[x][0] -  
// form_fields[x][1] -  
// form_fields[x][2] - ,     ,      .
//                                  text  radio.
// form_fields[x][3] -  ,     ,        

var form_fields = []

function QF_addField(field_id, field_type, def_value, dependence_field) {
	form_fields[form_fields.length] = [field_id, field_type, def_value, dependence_field]
}

function getFieldType(fld_name) {
	var i
	for (var i=0; i<form_fields.length; i++) {
		if (form_fields[i][0] == fld_name) {return form_fields[i][1]}
	}
	return undefined
}

function getFieldRec(fld_name) {
	//   ,   fld_name
	var i
	for (var i=0; i<form_fields.length; i++) {
		if (form_fields[i][0] == fld_name) {return form_fields[i]}
	}
	return ""
}

function isFieldEmpty(fld_name)
{
	// true,    ,  ,   ,     
	fld_rec = getFieldRec(fld_name)
	fld_val = document.getElementById(fld_name)
	if (fld_rec[2] && fld_val== fld_rec[2]) {return true}
	if (!fld_val) {return true}
	return false
}

QF_addField(c_sRangeFldID, "text", "", "")
QF_addField(c_sFuncFldID, "radio", c_sFuncValDoc, "")
QF_addField(c_sDateChk1FldID, "checkbox", "", "")
QF_addField(c_sDateChk2FldID, "checkbox", "", "")
QF_addField(c_sDateMinInputID, "text", "", "")
QF_addField(c_sDateMaxInputID, "text", "", "")

QF_addField(c_sCodeFld, "text", "", "")
QF_addField(c_sPhoneFld, "text", "", "")

QF_addField(c_sFamilyFld, "text", "", "")
QF_addField(c_sNameAndPatronymicFld, "text", "", "")
QF_addField(c_sFamilyMultiFld, "text", "", "")
QF_addField(c_sFamilyMultiFld + "_display", "radio", "", "")


var aConstrStates = []
var bSwitchEmptyQueryLink = false
var bSwitchHideConstr = false
var bSwitchToBuilder = true


function constrAddBlock(block_id, p_aStates, bSwitch) {
	for (var i=0; i<p_aStates.length; i++)
	{
		var usedBlocks = aConstrStates[i]
		usedBlocks[usedBlocks.length] = [block_id, p_aStates[i], bSwitch]
		aConstrStates[i] = usedBlocks
	}
}

function WordCount() // <% '     %>
{
	var i
	var eb
	var EditBox = document.getElementById("query_constr_tbl").getElementsByTagName("input");
	var wc = 0

	for(var i=0; i < EditBox.length;++i)
	{
		eb = EditBox[i]
		if((eb.type == 'text') && (eb.value != "") && (eb.getAttribute("_fld_type") != "DateField") && (eb.name!="min_date") &&(eb.name!="max_date") && (eb.name!="__VIEWSTATE"))
		{			
			wc = wc + 1
			if (wc >= 2) break
		}
	} // end for(i;;)
	return wc;
} // end pgm  WordCount


function WordInRowCount(r)
{
	var i
	var eb
	var EditBox = document.formQuery.elements;
	var Res=0
	for(var i=0; i < EditBox.length;++i)
	{
		owor='';
		eb=EditBox[i]
		if((eb.type=='text') && (eb.value!="") && (eb.getAttribute("row") == r))
		{
			Res=Res+1
		}
	}
	return Res
}

//         
var g_CheckValidExceptions = {}
//    
g_CheckValidExceptions["name_and_patronymic"] = /\s/g
//       
g_CheckValidExceptions["phone"] = /\s|\(|\)/g
//   -      
g_CheckValidExceptions["min_date"] = /\//g
g_CheckValidExceptions["max_date"] = /\//g

function CheckWordOnValidChars(wrd, psId)
{
	var RetVal = "";
	RetVal=''
	var mmRetVal = "";
	var mmwrd = wrd
	if( mmwrd.length > 3 )
	if( mmwrd.substring( 0, 2 ) == "//" ) //  .
	    mmwrd = trim(mmwrd.substring( 2, mmwrd.length ))
	var i
	var IsValidWord=false;
	var bar="";
	var cr=''
	var mmcr=''
	//  ( "g")
	var InvaridChar = /\[|\]|#|@|\^|&|\(|\)|\s|,|"|{|}|%|\//g
	var re =/[ ]/g
	var len=wrd.length;


	if((mmwrd.charAt(0) == '"') && (mmwrd.charAt(len-1)=='"'))
	{
		mmwrd = mmwrd.slice(1,-1)
		InvaridChar=/["]/g
	}
	IsValidWord = ((mmwrd == '""') ||(mmwrd == '""') ||(mmwrd == '""') ||
				(mmwrd == '"or"') ||(mmwrd == '"and"') ||(mmwrd == '"not"'))

	//    
	mmRetVal = mmwrd.match(InvaridChar)
	if (mmRetVal)
	{
		var TemplVal = new String(mmRetVal);
		//      
		if (typeof(g_CheckValidExceptions[psId]) != "undefined")
		{
			//   
			var exWrd = mmwrd.match(g_CheckValidExceptions[psId])
			var sExceptions = new String(exWrd)
			//        ,
			//   
			if (TemplVal.toString() != sExceptions.toString())
			{
				RetVal = TemplVal.replace(re,"[]");
			}
		} else
			RetVal = TemplVal.replace(re,"[]");
	}
	return RetVal
}


function IsQueryValid()
{
	var EditBox = document.getElementById("query_constr_tbl").getElementsByTagName('input');
	var RetVal = false
	var eb
	var wrd=""
	var invalidchar=''
	var i

	for(var i=0; i < EditBox.length;++i)
	{
		eb = EditBox[i]
		if (eb.type != "text") continue
		if (eb.name == c_sCodeFld) continue
		if (eb.name == c_sPhoneFld) continue
		if (eb.name == c_sFamilyFld) continue
		if (eb.name == c_sNameAndPatronymicFld) continue
		wrd = trim(eb.value)
		if(wrd.length != eb.value.length) eb.value = wrd
		if(wrd != "")
		{
			var sId = eb.getAttribute( "id" )
			invalidchar = CheckWordOnValidChars(wrd, sId)
		}
		if (invalidchar)
		{
			alert('      { ' + invalidchar + ' }\n( - '+wrd+') ')
			break;
		}
		wrd = ""
	} // end for(i;;)

	RetVal=(invalidchar=="")
	return RetVal;
}


function InsertQuoter(Word)
{
	var RetStr='';
	var cr;
	var i

	RetStr=Word

	if ((Word == "") ||(Word == "") ||(Word == "") ||
		(Word == "or") ||(Word == "and") ||(Word == "not") )

	RetStr='"'+RetStr+'"'

	return RetStr
}


function RowText(r)
{
	var i
	var eb
	var eb1
	var EditBox = document.getElementsByTagName('input');
	var ow = "";
	var owor = ""
	var logical = ""

	for(var i = 0; i < EditBox.length; ++i)
	{
		owor = '';
		eb = EditBox[i]
		if((eb.type == 'text') && (eb.value != "") && (eb.getAttribute("row") == r))
		{
			if ((document.getElementsByName(c_sFuncFldID)[0].checked) && (r!=4))
				logical = " [" + document.all(c_sRangeFldID).value +"] ";
			else
				logical = eb.getAttribute("vcard_name")             
			if (eb.getAttribute("blockname") == "or")
			{
				eb1=EditBox[i+1];
				if(eb1.value!="" && eb1.getAttribute("blockname") == "or")
				{
				    owor='('+ InsertQuoter(eb.value) +'  '+ InsertQuoter(eb1.value) +')'
					if(ow != "")
						ow = ow + logical + owor
					else
						ow = owor
				}
				else
				{
					if(ow!="")
						ow = ow + logical + InsertQuoter(eb.value)
					else
						ow = InsertQuoter(eb.value)
				}
				break;
			}
			else
			{
				if(ow!="")
					ow = ow + logical + InsertQuoter(eb.value)
				else
					ow = InsertQuoter(eb.value)
			}
		} // if((eb.type=='text') && (eb.value!="") && (eb.row==r))
	} // for(var i = 0; i < EditBox.length; ++i)
	if ((document.getElementsByName(c_sFuncFldID)[0].checked) && (ow!="") && (r!=4))
		ow = "near("+ow+")"
	return ow
} // function RowText(r)

function SaveFieldVals() {
	var result_arr = []
	var result_string
	var fld
	var fld_val
	var i
	for (var i = 0; i < form_fields.length; i++) 
	{
		fld_name = form_fields[i][0]
		fld_type = form_fields[i][1]
		fld_def_val = form_fields[i][2]
		fld_dep_field = form_fields[i][3]
		if (fld_dep_field) {
			if (isFieldEmpty(fld_name)) {continue}
		}
		if (fld_type == "text" || fld_type == "hidden" || fld_type == "date") {
			fld_val = document.getElementById(fld_name).value
			//        
			fld_val = fld_val.replace(/\r/g, "")
			fld_val = fld_val.replace(/\n/g, "_nl_")
			if (fld_val && document.getElementById(fld_name).disabled == false) {
				result_arr[result_arr.length] = fld_name + c_sDelimiter1 + fld_val
			}
		}
		if (fld_type == "radio") {
			var opts = document.getElementsByName(fld_name)
			var j
			for (j = 0; j < opts.length; j++) {
				if (opts[j].checked) {
					fld_val = opts[j].value
					if (fld_val != fld_def_val) {
						result_arr[result_arr.length] = fld_name + c_sDelimiter1 + fld_val
					}
				}
			}
		}
		if (fld_type == "checkbox") {
			fld = document.getElementById(fld_name)
			if (fld.checked) { fld_val = fld.value } else {fld_val = ""}
			if (fld_val && document.getElementById(fld_name).disabled == false) {
				result_arr[result_arr.length] = fld_name + c_sDelimiter1 + fld_val
			}
		}
		/*
		if (fld_type == "date") {
			fld_val = getDate(fld_name, <%=lv%>)
			if (isDateFieldEnabled(fld_name)) {
				result_arr[result_arr.length] = fld_name + "<%=c_sDelimiter1%>" + fld_val
			}
		}
		*/
	}
	         result_string = result_arr.join(" "+c_sDelimiter2)
	if( trim(result_string) != "") {result_string = "{Fields:" + result_string + ":Fields}"}
	  return result_string
}

var CQ_extensions = new Array()

function CQ_registerExtension(func_name) {
	CQ_extensions[CQ_extensions.length] = func_name
}


var sDateBaseField = c_sDateBaseFieldID
function setDateBaseField(base_field_id) {
	sDateBaseField = base_field_id
}
												
												
function CreateQuery()
{
	var arr_row       = new Array();
	var arr_WordInRow = new Array();

	var row_After_AndNot, WordInRow_After_AndNot;

	var SpecialRow = "";
	var ResultRow='';
	var ResultWordCount=0
	var bMakeMultiQuery = false; //   
	var aSubstitutions = [];     //  ,    

	var StartDate = document.getElementById(c_sDateMinInputID).value;
	var EndDate = document.getElementById(c_sDateMaxInputID).value;

	if( IsQueryValid() )
	{
		ResultWordCount=0
		ResultRow = "";
		var k = 0;
		for(var i=1;i<=js_iarr_max;i++)
		{
			arr_WordInRow[i-1] = WordInRowCount(i);
			ResultWordCount += arr_WordInRow[i-1];
			arr_row[i-1]       = RowText(i);
			if( ResultRow.length <= 0 )
			{
				if( arr_row[i-1] != "" ) { ResultRow = arr_row[i-1]; k++; }
			} else
			{
				if( arr_row[i-1] != "" )
				{
					if( k == 1 ) ResultRow = "(" + ResultRow + ")"
					k++;
					ResultRow += ("  (" + arr_row[i-1] + ")");
				}
			} // end else
		} // end for(i;;)

		WordInRow_After_AndNot = WordInRowCount(js_iarr_max+1);
		row_After_AndNot       = RowText(js_iarr_max+1);

		if((row_After_AndNot!="") && (ResultWordCount>0) && (ResultRow!=""))
			ResultRow = '('+ResultRow+')'+ "   "
		else
			if((row_After_AndNot!="") && (WordInRow_After_AndNot>1))
				row_After_AndNot = "  " + row_After_AndNot;

		ResultRow += row_After_AndNot

		// <% '  %>

		if( (document.getElementById("dateck1").checked)||(document.getElementById("dateck2").checked) )
		{
			if( ResultRow == "" )
			{
			    DST=""
			}
			else
			    DST="  "

			DST += (sDateBaseField + ":");

			EndDateString = DST +" <= "+ EndDate

			if( ResultRow != "" )
			    ResultRow = " (" + ResultRow + ") "

			if( (document.getElementById("dateck1").checked) && (document.getElementById("dateck2").checked) )
			{
				StartDateString = DST + " >= " + StartDate
				ResultRow = "(" + ResultRow  + StartDateString+") "
				             + "  " + (sDateBaseField + ":") + " <= "
				             + EndDate;
			} else
			if( (document.getElementById("dateck1").checked) && (!document.getElementById("dateck2").checked) )
			{
				StartDateString = DST + " >= " + StartDate
				ResultRow = ResultRow  + StartDateString
			} else
			if( (!document.getElementById("dateck1").checked) && (document.getElementById("dateck2").checked) )
			{
				ResultRow =  ResultRow  + EndDateString
			}
		} // end if

		//// ---- Special Row --- init ---
		/* 
		  ,      - 
		 , , 
		*/
		SpecialRow = "";

		//    text
		var sSpecial = trim(document.getElementById(c_sCodeFld).value)
		if (sSpecial != "")
			SpecialRow += SpecialRow == "" ? "text(" + sSpecial + ")" : "  text(" + sSpecial + ")"

		//   phone
		var oPhone = getPhoneQuery();
		if (typeof(oPhone) == "string") 
		{
			if (oPhone != "")
				SpecialRow += SpecialRow == "" ? oPhone : "  " + oPhone
		} 
		if (oPhone instanceof Array)
		{
			bMakeMultiQuery = true;
			aSubstitutions = oPhone;
			//        
			if( SpecialRow != "" )
				SpecialRow += "  (_slot_)"
			else
				SpecialRow = "_slot_"
		}

		var oFIO = getFioQuery();
		if (typeof(oFIO) == "string") 
		{
			if (oFIO == "error") return "";
			if (oFIO)
			{ 
				if( SpecialRow != "" )
		        	SpecialRow += "  (" + oFIO +")"
		    	else
		        	SpecialRow = oFIO
	        }
		}
		if (oFIO instanceof Array)
		{
			bMakeMultiQuery = true;
			aSubstitutions = oFIO;
			//        
			if( SpecialRow != "" )
				SpecialRow += "  (_slot_)"
			else
				SpecialRow = "_slot_"
		}
		
	    /////~~~~~~~~~~~~~~~~~~~~~~
		//           
		if( SpecialRow != "" )
		{
			if( ResultRow != "" )
			{
				if( ResultRow.length >= 2 )
					if( ResultRow.substring( 0, 2 ) == "//" )
						ResultRow = trim( ResultRow.substring( 2 , ResultRow.length ) )
				ResultRow = "(" + ResultRow +")  (" + SpecialRow + ")"
			} else 
				ResultRow = SpecialRow
		} // end if

		if (ResultRow!="")
			if( ResultRow.length > 2 )
				if( ResultRow.substring( 0, 2 ) != "//" )
					ResultRow="// "+ResultRow
		
		for (var num_ext = 0; num_ext < CQ_extensions.length; num_ext++)
		{
			ResultRow += eval(CQ_extensions[num_ext])
		} // end for(;;)
		if (bMakeMultiQuery) //      
		{
			ResultRow = MakeMultiQuery(ResultRow, aSubstitutions, " " + SaveFieldVals())
		} else 
			if (ResultRow.length > 0) {ResultRow += " " + SaveFieldVals()}
		return ResultRow
	} else // IsQueryValid()
	{
		return ""
	} // end else  IsQueryValid()

} // end pgm  CreateQuery



function getFioQuery()
{
	var aFios = checkMultiLineMode("fio")
	if (aFios)
	{
		//       fio(
		var aFiosQuer = mapArray( function(x) {x = trim(x); return x ? "FIO(" + x + ")" : ""} , aFios)
		return [aFiosQuer, aFios];
	}
	
	var sFamily = trim(document.getElementById(c_sFamilyFld).value)
	var sNameAndPatronymic = trim(document.getElementById(c_sNameAndPatronymicFld).value)

	if( (sFamily + sNameAndPatronymic)  != "" )
	{
		if( sFamily == "" )
		{
			alert( "   ' '\n"
			      +" '' / , ..  '/'" );
			return "error";
		} // end if  sFamily != ""
		var sFIO = sFamily;
		if( typeof(sNameAndPatronymic) == "string" )
		if( sNameAndPatronymic != "" )
		{
			sFIO += " " + sNameAndPatronymic;
		}
		sFIO = 'FIO('+sFIO+')';
		return sFIO;
	} // end if  sFamily + sNameAndPatronymic != ""
	return "";
}

function checkMultiLineMode(psFldName)
{
	//     -    
	var oRow = elem("multiFioInputRow")
	var oMultiLineFld = elem(c_sFamilyMultiFld)
	var bMulti = (oRow.style.display != "none" && oMultiLineFld.getAttribute("constrField") == psFldName)
	if (!bMulti) return undefined;
	var sLines = elem(c_sFamilyMultiFld).value;
	sLines = trim(sLines)
	elem(c_sFamilyMultiFld).value = sLines
	if (!sLines) return undefined;
	//     
	sLines = sLines.replace(/\r/g, "")
	var aLines = sLines.split("\n");
	return aLines;
}

function MakeMultiQuery(psResultRow, paSubstitutions, psConstrState)
{
	psResultRow = psResultRow.replace(/</g, "&lt;")
	psResultRow = psResultRow.replace(/>/g, "&gt;")
	var aQueries = paSubstitutions[0]
	var aVals = paSubstitutions[1]
	if (aQueries.length == 0 || aQueries.join("") == "") return "";
	var sMultiQuery = "<?xml version=\"1.0\" encoding=\"windows-1251\" ?>";
	//   
	//    
	var aTmp = aQueries[0].split(/\(/)
	var sFunc = aTmp[0]
	var sQuerName = psResultRow.replace(/_slot_/g, sFunc + "(" + aVals.join(", ") + ")");
	sQuerName = trim(sQuerName.replace(/\/\//g, ""));
	sMultiQuery += "<MultiQuery name=\"" + sQuerName + "\" constr_state=\"" + psConstrState + "\">";
	for (var i = aQueries.length - 1; i >=0  ; i--)
	{
		if (!aQueries[i]) continue;
		var psQueryPart = psResultRow.replace(/_slot_/g, aQueries[i]);
		sMultiQuery += "<part mark=\"*\">" + psQueryPart + "</part>"
	}
	sMultiQuery += "</MultiQuery>";
	return sMultiQuery;
}

function getPhoneQuery()
{
	var aPhones = checkMultiLineMode("phone")
	if (aPhones)
	{
		//       phone(
		var aPhonesQuer = mapArray( function(x) {x = trim(x); return x ? "phone('" + x + "')" : ""} , aPhones)
		return [aPhonesQuer, aPhones];
	}
	var sPhone = trim(elem(c_sPhoneFld).value)
	return sPhone ? "phone(\"" + sPhone + "\")" : "";
}

function OnEngenKeyDown()
{
	if (event.keyCode==13)
	    StartEgenQueryPlusFolder();
	  //StartEgenQuery()  27/02/07
}


function oninfoportr(Sender)
{
	if(Sender.checked)
		document.all.Infoportr.value="1"
	else
		document.all.Infoportr.value="0"
}



function WordOf(object)
{

	var retval=""
	if(object)
	if(object.value!="")
	    retval= object.value

	return retval;
}


function GoTo(Idx)
{
	document.formQuery.qry.value = CreateQuery()	
	return (document.formQuery.qry.value != "")
}


var arr_TestEgenQuery = new Array
( [ "", ""],
  ["   ", "Is not data in query"],
  ["   ", "Error in format of data"],
  ["  ", "impossible ratio of data"],
  [ "", ""]
) ;

function jsTestDateEgenQuery( xLv )
{

   var chk1 = document.getElementById( "dateck1" )
   var chk2 = document.getElementById( "dateck2" )

   if( chk1.checked == false && chk2.checked == false ) return 1;

   var inp1 = document.getElementById( "min_date" )
   var inp2 = document.getElementById( "max_date" )

   if( chk1.checked == true && chk2.checked == false )
   {
           txt = trim( inp1.value )
       if( txt.length <= 0 ) return 1; // <%'   %>

           dat = jsTestDate( txt, xLv )
       if( dat == null ) return 2; // <% '     %>

       return 0;
   } // end if

   if( chk1.checked == false && chk2.checked == true )
   {
           txt = trim( inp2.value )
       if( txt.length <= 0 ) return 1; // <%'   %>

           dat = jsTestDate( txt, xLv )
       if( dat == null ) return 2; // <% '     %>

       return 0;
   } // end if

       var tx1 = trim( inp1.value )
       if( tx1.length <= 0 ) return 1; // <%'   %>

       var dt1 = jsTestDate( tx1, xLv )
       if( dt1 == null ) return 2; // <% '     %>

       var tx2 = trim( inp2.value )
       if( tx2.length <= 0 ) return 1; // <%'   %>

       var dt2 = jsTestDate( tx2, xLv )
       if( dt2 == null ) return 2; // <% '     %>

       if( dt1 > dt2 )
           return 3;       // <% ' min > max %>

       return 0
} // end pgm  jsTestDateEgenQuery


function jsTestEgenQuery()
{
   var kod = jsTestDateEgenQuery( lv__Test )
   if( kod >= 2 ) return kod;     
   if( kod == 0 ) return 0;
   //  kod == 1 - <% '   %>
   
   // <% '  -     %>
   var cntWord = WordCount();   
   if( cntWord > 0 ) return 0;
   
   var txt,dat;
   var inp = document.getElementById( "code" )
   if( inp == null ) { alert( "Error : not find by id 'code' jsTestEgenQuery" ); return 0; }
       txt = trim( inp.value )       
   if( txt.length > 0 ) return 0;

       inp = document.getElementById( "phone" )
       txt = trim( inp.value )
   if( txt.length > 0 ) return 0;

       inp = document.getElementById( "family" )
       txt = trim( inp.value )
   if( txt.length > 0 ) return 0;

       inp = document.getElementById( "name_and_patronymic" )
       txt = trim( inp.value )
   if( txt.length > 0 ) return 0;
   
   if (elem("multiFioInputRow").style.display != "none")
   {
	   inp = document.getElementById( "family_multi" )
	   txt = trim( inp.value )
	   if( txt.length > 0 ) return 0;
   }

   return 1; // <% '   %>
} // end pgm  jsTestEgenQuery

function StartEgenQueryPlusFolder()
{
	try
	{
	js_TestFoldersParm();
    }
    catch( e ) { }

    var r = js_test_FIFOSetQueryNumber(); // <% ' . itQuery.sub %>

    if( r >= 0 )
    StartEgenQuery()

} // end pgm

function StartEgenQuery()
{

    var codTest = jsTestEgenQuery();
    
    if( codTest > 0 )
    {

        var arr_soob = arr_TestEgenQuery[ codTest ]
    	alert(  arr_soob[ (lv__Test-1) ] );    	

    	return;
    }

    /* 18.12.06
	var IsQueryEmpty = (WordCount()==0)
	if (IsQueryEmpty)
				{
    	    	alert("<% =g_lngQuery(3, lv) %>")
				return
				}
    */

	var CanQuery=GoTo(0)
    
	if(g_fStarted)
		 g_fStarted = false		 
	if(CanQuery)
	{
		
		if(document.formQuery.redirecter!=null)			
			document.formQuery.redirecter.value="1";
			if (document.getElementById("QueryMode")!=null){			   
			   if(document.getElementById("Constr").style.display!="none")
			      document.getElementById("QueryMode").value = "0";
			      else
			      document.getElementById("QueryMode").value = "1";			      
			}		
					
			//   QueryText -              
  		StartQuery()
		g_fStarted = true;
		//anmg = window.setInterval("AnimatePict_eng()", 400) - ,  
		//       
	}
	
}

function TriggerQueryForms(FormType)
{
	var IsQueryValid = false
	var IsQueryEmpty = false
	IsQueryEmpty = (WordCount() == 0)
	var bConstrQuery = false
	if(FormType == "ConstrQuery") //     
	{
		IsQueryValid = GoTo(0)
		if(IsQueryEmpty||IsQueryValid)
		{
			switchToMode(g_sConstrStateManual)
		}
	}
	else
	{ //     

	    // <% ' 05.02.07  %>
	    var qry = trim(document.formQuery.qry.value)
	    if( qry == "" ) resetQueryForm()
	    else
	    {
		      resetQueryForm()
	       //   
	          bConstrQuery = parseQuery( qry )
	    }
	    var restoredQuery = trim(CreateQuery())
	    //alert( "qry="+qry+"\nres="+restoredQuery+"\n<%=Len(p_sQuery)%>" )
	    //~~~~~

		if (p_sQuery.length > 0 && qry != restoredQuery )
		{
			//        -
			//        
			var sMsg = ""
			if (bConstrQuery)
				sMsg = g_lngQueryEngine[1]
			else
				sMsg = g_lngQueryEngine[2]
			if (confirm(sMsg))
			{
				//resetQueryForm()
				switchToMode(g_sConstrStateConstr)
			}
		} else {
			switchToMode(g_sConstrStateConstr)
		}
	}
	return false
}

function switchToManual()
{
	TriggerQueryForms("ConstrQuery")
}

var STM_extensions = new Array()

function STM_registerExtension(func_name) {
	STM_extensions[STM_extensions.length] = func_name
}

/**
    -  , ,
     
 pbConfirm -  , 
   ,    
*/


function switchToMode(p_sMode, pbConfirm) {	
	if (p_sMode==g_sConstrStateConstr)//1
	{
		disableMenuItem("CONSTRUCTOR")
		enableMenuItem("QUERY")
		if(g_bAspnetForm)
		{
		    if(document.formQuery.qry.value=="")
		    {
		       resetQueryForm();
		       p_sQuery="";
		    }
		    parseQuery(document.formQuery.qry.value);
	        var restoredQuery = CreateQuery()
	        if (document.formQuery.qry.value != restoredQuery) 
	        {
		       if (confirm(Dict11))
		       { 
			       resetQueryForm();
			       //document.formQuery.qry.value="";
			       p_sQuery="";
			       }
			   else  
			   	   p_sMode=0;   
			  			   			
		    }
		}		
		
	}
	if (p_sMode==g_sConstrStateManual)//0
	{
		disableMenuItem("QUERY")
		enableMenuItem("CONSTRUCTOR")		
		if(g_bAspnetForm)
		{		
		    if(document.getElementById("Constr").style.display!="none")
	        {
	            var restoredQuery = CreateQuery()
	            if(restoredQuery!="")  
                document.formQuery.qry.value=restoredQuery;
			    p_sQuery=restoredQuery;		    
			}		    
		}		
	}	
	var state = aConstrStates[p_sMode]
	if (!state) {return false}
	for (var i=0; i<state.length; i++) {
		if (state[i][2]) {
			if(document.getElementById(state[i][0])!=null)
			document.getElementById(state[i][0]).style.display = state[i][1]
		}
	}
	
	//    -      .
	//    ,    
	//switchHelpRubric(p_sMode)
	
	for (ext_num=0; ext_num < STM_extensions.length;ext_num++)
	{
		eval(STM_extensions[ext_num].replace("%1","'" + p_sMode + "'"))		
	}		
	
}

function SetRange(flag)
{
	document.all[c_sRangeFldID].disabled=flag;
	if (!flag && !document.all[c_sRangeFldID].value) {document.all[c_sRangeFldID].value = 1}
	if (flag) {document.all[c_sRangeFldID].value = ""}
}


function setQueryFormField(fld_name, fld_val) {
	fld_type = getFieldType(fld_name)
	fld = getByNameOrId(fld_name)
	if (fld) {
		if (fld_type == "text"||fld_type == "hidden") {
		    //      _nl_   \n
			fld_val = fld_val.replace(/_nl_/g, "\n")
			fld.value = fld_val
			fld.disabled = false
		}
		if (fld_type == "radio") {
			var aRadios = document.getElementsByName(fld_name)
			for (j = 0; j < aRadios.length; j++) 
			{
				if (aRadios[j].value == fld_val)
					aRadios[j].click()
			}
		}
		if (fld_type == "checkbox") {
			var bCheck = fld_val ? true : false
			if (bCheck != fld.checked) fld.click()
		}
	}
	/*
	if (fld_type == "date") {
		if (isExists(fld_name)) {
			setDate(fld_val, fld_name, <%=lv%>)
			enableDateField(fld_name, true)
		}
	}
	*/
}




function parseQuery(query, fld_name) {
	//  fld_name,     .   ,
	//     ,      .
	if (query == "") {query = p_sQuery}
	var sQuery = trim(query);
	var bConstrQuery = false // ,       
	var sParse = null;
	var re1 = /{Fields:([^}]+):Fields}/g
	var parsedQuery
	var allMatches = []
	while ((parsedQuery = re1.exec(query)) != null) {
		query = query.slice(parsedQuery.lastIndex, query.length + 1)
			if( sParse == null )
			    sParse = parsedQuery[0]		
		var re2 =  new RegExp(c_sDelimiter1, "g");   ///@/g
		//re2.replace("c_sDelimiter1",c_sDelimiter1);		
		if (re2.test(parsedQuery[1])) {
			allMatches[allMatches.length] = parsedQuery[1]
		}
	} // end while
	if (allMatches.length > 0) bConstrQuery = true
	// <% ' 5/02/07  %>
	if (allMatches.length>0)
	if( sParse != null )
	{
		var kk = sQuery.indexOf( sParse )
		if( kk >= 0 ) sQuery = trim(sQuery.substring( 0, kk ))
	}
	/*
	  ,      IE 7
	if (allMatches.length<=0)
	if( sQuery.length > 0 )
	{

		var cnt0 = 0;

		sQuery = sQuery.replace( "  ", " | " )
		sQuery = sQuery.replace( "  ",   " & " )
		var aQueryOr = sQuery.split( "|" )

		var aQueryAnd, fldx;
		if( typeof aQueryOr != "object" ) return;
		if( aQueryOr.length <= 0 ) return;

		for(var iOr=0;iOr<aQueryOr.length;iOr++)
		{
			    aQueryOr[iOr] = trim(aQueryOr[iOr])
			if( aQueryOr[iOr] == "" ) continue;

			aQueryAnd = aQueryOr[iOr].split( "&" )

		    if( typeof aQueryAnd != "object" ) continue;
		    if( aQueryAnd.length <= 0 ) continue;

		    for(var iAnd=0;iAnd<aQueryAnd.length;iAnd++)
		    {
			        aQueryAnd[iAnd] = trim( aQueryAnd[iAnd].replace( "(", "" ).replace( ")", "" ) )
			    if( aQueryAnd[iAnd] == "" ) continue;
			        aQueryAnd[iAnd] = aQueryAnd[iAnd].replace( "  ", " " )

			    var fldn = "word"+(iOr+1).toString(10)+""+(iAnd+1).toString(10)

			        fldx = document.getElementById( fldn )
			    if( fldx != null )
			    {
				    if( typeof fldx.type != "string"  ) continue;
				    if( fldx.type != "text" ) continue;

				    cnt0++;
				    if( cnt0 == 1 )
				    if( aQueryAnd[iAnd].length > 3 )
				    if( aQueryAnd[iAnd].substring( 0, 2 ) == "//" )
				        aQueryAnd[iAnd] = trim( aQueryAnd[iAnd].substring( 2, aQueryAnd[iAnd].length ) )

				     //setQueryFormField( fldn, aQueryAnd[iAnd] )
			         fldx.setAttribute( "value", aQueryAnd[iAnd] )
		        } //else alert( "No fld" )
		    } // end for(iAnd;;)

		} // end for(iOr;;)

		return;
	} // end if
		*/
	// ~~~~
	var allPairs = []
	if (allMatches.length>0) {
		allPairs = allMatches[0].split(c_sDelimiter2)
	}
	for (var i=0; i<allPairs.length; i++) {
		var inputIDAndVal = []
		    inputIDAndVal = trim(allPairs[i]).split(c_sDelimiter1)
		var fld_type = getFieldType(inputIDAndVal[0])
		if (fld_name) {
			if (fld_name == inputIDAndVal[0]) {return inputIDAndVal[1]} else {continue}
		}
		setQueryFormField(inputIDAndVal[0], inputIDAndVal[1])
		// enable or disable word count select prior to radio button (words/document) value
		if (inputIDAndVal[0] == c_sFuncFldID) {
			if (inputIDAndVal[1] == c_sFuncValWord) {SetRange(false)} else {SetRange(true)}
		}
	} // end for(i;;)
	return bConstrQuery
} // end pgm

var RQF_extensions = new Array()

function RQF_registerExtension(func_name) {
	RQF_extensions[RQF_extensions.length] = func_name
}

function resetQueryForm() {
	for (var i = 0; i < form_fields.length; i++) {
		var oFld = elem(form_fields[i][0])
		if (form_fields[i][1] == "text") {
			document.getElementById(form_fields[i][0]).value = ""
			if (oFld.onblur) oFld.onblur()
		}
		if (form_fields[i][1] == "radio") {
			var opts = document.getElementsByName(form_fields[i][0])
			var j
			for (j = 0; j < opts.length; j++) {
				if (opts[j].value == form_fields[i][2]) {
					opts[j].checked = true
				}
			}
		}
		if (form_fields[i][1] == "checkbox") {
			var oChk = elem(form_fields[i][0])
			if (oChk.checked) oChk.click()
		}
		if (form_fields[i][1] == "date") {
		}
		
	}
	for (var num_ext = 0; num_ext < RQF_extensions.length; num_ext++) {
		eval(RQF_extensions[num_ext])
	}
}

function getQuery() {
	return p_sQuery
}


function getRadioOptionByVal(psId, psVal)
{
	var aRadio = document.getElementsByName(psId)
	for (var i = 0; i < aRadio.length; i++)
		if (aRadio[i].value == psVal) return aRadio[i]
	return undefined
}

function expandMultiLineFld(psFld, poSender)
{
	//  ,    
	var oRow = elem("multiFioInputRow")
	//   
	var oField = elem(c_sFamilyMultiFld) 
	//  , ,    
	var isCurrent = function (psFldInner) {return (psFldInner == psFld) }
	//   
	var aSingleFld = [
						[elem(c_sFamilyFld), isCurrent("fio")], 
						[elem(c_sNameAndPatronymicFld), isCurrent("fio")], 
						[elem(c_sPhoneFld), isCurrent("phone")]
					 ]

	if (oRow.style.display == "none") //    
	{
		//    
		oRow.style.display = ""
		oField.setAttribute("constrField", psFld)
		//     
		for (var i = 0; i < aSingleFld.length; i++)
			if (aSingleFld[i][1]) aSingleFld[i][0].style.visibility = "hidden"

		oField.focus();
	}
	else // //    
	{
        if (oField.value != "" && !confirm("  . ?"))
            return;

        oField.value = "";

		if (oField.getAttribute("constrField") != psFld) //    -   
		{
			oField.setAttribute("constrField", psFld)
			//     
			for (var i = 0; i < aSingleFld.length; i++)
			{
				if (aSingleFld[i][1]) //   , 
					aSingleFld[i][0].style.visibility = "hidden"
				else
					aSingleFld[i][0].style.visibility = "";
			}

    		oField.focus();
		}
		else //       -     
		{
			oRow.style.display = "none";
			//     
			bFocusSet = false;
			for (var i = 0; i < aSingleFld.length; i++)
				if (aSingleFld[i][1] && aSingleFld[i][0].style.visibility != "")
				{
				    aSingleFld[i][0].style.visibility = "";
				    if (!bFocusSet)
				    {
        			    aSingleFld[i][0].focus();
        			    bFocusSet = true;
        			}
				}
		}
	}

	highlightTitle(oRow.style.display, psFld)
	if (oRow.style.display == "none")
		getRadioOptionByVal(c_sFamilyMultiFld+"_display", "none").checked = true
	else
		getRadioOptionByVal(c_sFamilyMultiFld+"_display", psFld).checked = true
}

function setDispStyle(poSender, psElem)
{
    if (poSender.value == "none")
        return;

	var oRow = elem(psElem)
	oRow.style.display = poSender.value == "none" ? "none" : ""
	//      
	//   
	var isCurrent = function (psFldInner) {return (psFldInner == poSender.value) }
	var aSingleFld = [
						[elem(c_sFamilyFld), isCurrent("fio")], 
						[elem(c_sNameAndPatronymicFld), isCurrent("fio")], 
						[elem(c_sPhoneFld), isCurrent("phone")]
					 ]
	//     ,     
	for (var i = 0; i < aSingleFld.length; i++)
	{
		if (aSingleFld[i][1]) //   , 
			aSingleFld[i][0].style.visibility = oRow.style.display == "none" ? "" : "hidden"
		else
			aSingleFld[i][0].style.visibility = oRow.style.display == "none" ? "hidden" : ""
	}
	elem(c_sFamilyMultiFld).setAttribute("constrField", poSender.value)
	highlightTitle(oRow.style.display, poSender.value)
}

function highlightTitle(psDispStyle, psFld)
{
	//       
	var oPhoneFldTitle = elem("phone_fld_title")
	var oFioFldTitle = elem("fio_fld_title")
	if (psDispStyle == "none")
	{
		oPhoneFldTitle.style.border = "none"
		oFioFldTitle.style.border = "none"
	} else {
		if (psFld == "phone")
		{
			oPhoneFldTitle.style.border = "solid blue 1px"
			oFioFldTitle.style.border = "none"
		} else {
			oPhoneFldTitle.style.border = "none"
			oFioFldTitle.style.border = "solid blue 1px"
		}
	}
}


function testQueryArea()
{

	var div = document.getElementById( "Constr" )
	if( div == null ) return -1;

	var nState = -1;

	if( div.style.display == "none" )
	    return 10; //  "QUERY"  == 0 '    ( )
	else
	if( div.style.display == "block" )
	    return 11; //  "CONSTRUCTOR" == 1 '  

	return (nState)
} // end pgm

function applyParamsNewQuery()
{
	var nState = testQueryArea()
	if( nState < 10 )
	{
		return SetParams()
	}

    var qStr = makeChangeStr() // . Options.sub
    if(!qStr)
    {
        alert(g_lngNoChanges)
        return qStr;
    }

    document.body.style.cursor="wait"

    var parm = "opts_save.asp?" + qStr

        var xmlhttp = createXmlHttp()
        if( xmlhttp == null ) { alert( "Error: xmlhttp == null" ); return false; }

            xmlhttp.open("GET", parm, false)
            xmlhttp.onreadystatechange = function ()
            {
                if (xmlhttp.readyState == 4) js_SaveParmWithHTTP_End();
            }
            xmlhttp.send(null)

     var qr = ""
     if( nState == 11 ) //  "CONSTRUCTOR" == 1 '  
     {
        qr = trim(CreateQuery())
     } else
     {
	    qr = trim(document.formQuery.qry.value)
     }

     parm = "opts_save.asp?save_func=SaveStringParm&name=query_text&value="
          + escape( qr )

            xmlhttp.open("GET", parm, false)
            xmlhttp.onreadystatechange = function ()
            {
                if (xmlhttp.readyState == 4) js_SaveParmWithHTTP_End();
            }
            xmlhttp.send(null)


    saveComplete( "setmode="+nState );

    document.body.style.cursor="auto"

    return qStr;
} // end pgm

/**
      .
   p_sConstrState
*/

function setConstrState(pnState, pbForce)
{
	//   
	parseQuery(p_sQuery)
	//       15.08.07
	if( pnState >= 10 )
	{
		switchToMode(pnState-10);
		return;
	} // end if

	//    
	if (pnState == g_sConstrStateManual)
	{
		switchToMode(pnState)
	}
	/*
	   .     ,
	    pbForce = true
	*/
	if (pnState == g_sConstrStateConstr)
	{
		var restoredQuery = CreateQuery()
		var bSwitch = (restoredQuery == p_sQuery || pbForce) ? true : false
		//if (!bSwitch) bSwitch = (pbForce || confirm("<%=g_lngQueryEngine(1, lv)%>")) ? true : false
		if (bSwitch) {switchToMode(pnState)} else {switchToMode(g_sConstrStateManual)}
	}
	/*
	     .
	      ,
	  -   
	*/
	if (pnState == g_sConstrStateHidden)
	{
		var restoredQuery = CreateQuery()
		var bSwitch = (restoredQuery == p_sQuery) ? true : false
		if (bSwitch) {switchToMode(pnState)} else {switchToMode(g_sConstrStateManual)}
	}
} // setConstrState




function AnimatePict_eng()
{
	if (document.all.Engenagif)
	{
		s = "document['Engenagif'].src=g_gStartQImage" + g_nCurrPicIndex + ".src"
		t=eval(s)
	}

	if (document.all.Engenagif1)
	{
		s1 = "document['Engenagif1'].src=g_gStartQImage" + g_nCurrPicIndex + ".src"
		t1 = eval(s1)
	}
    g_nCurrPicIndex++
	if (g_nCurrPicIndex == 7)
    	g_nCurrPicIndex = 1
}

	///SetOnEnter()
	//  ""
	function SetOnEnter()
	{
	var EditBox=document.formQuery.getElementsByTagName('input');
	var i
	var eb
    
    for(var i=0; i<EditBox.length;++i)
		{
		eb = EditBox[i]
		eb.onkeydown = OnEngenKeyDown

		}

	}
	

// getDay, getMonth, getYear -   , ,         ID

// getDatePart -          (, , )
//     

function getDatePart(date, date_part, nLng) {
	//date_part can be "d" - day, "m" - month or "y" - year
	var res = ""
	var aDateParts = []
	switch (nLng) {
		case 1: //russian language
			aDateParts = date.split(".")
			if (date_part == "d") {res = parseInt(aDateParts[0])}
			if (date_part == "m") {res = parseInt(aDateParts[1])}
			if (date_part == "y") {res = parseInt(aDateParts[2])}
			break
		case 2: //english language
			aDateParts = date.split(".")
			if (date_part == "d") {res = parseInt(aDateParts[1])}
			if (date_part == "m") {res = parseInt(aDateParts[0])}
			if (date_part == "y") {res = parseInt(aDateParts[2])}
	}
	return res
}

// getDate -       ,       

function getDate(dateSelectID, nLng) {
	var date_str = "";
	switch (nLng) {
		case 1:
			date_str = getDay(dateSelectID) + "." + getMonth(dateSelectID) + "." + getYear(dateSelectID)
			break
		case 2:
			date_str = getMonth(dateSelectID) + "." + getDay(dateSelectID) + "." + getYear(dateSelectID)
	}
	return date_str
}
function addZero(d_m){
    if (eval(d_m)<10){
        d_m="0"+d_m;
    }
    return d_m;
}

// setDate -        ID
function setDate(date, dateSelectID, nLng) {
	if(langv==1){
	document.getElementById(dateSelectID).value=addZero(getDatePart(date, "d", nLng))+"."+addZero(getDatePart(date, "m", nLng))+"."+getDatePart(date, "y", nLng);
	}else{
	document.getElementById(dateSelectID).value=addZero(getDatePart(date, "m", nLng))+"."+addZero(getDatePart(date, "d", nLng))+"."+getDatePart(date, "y", nLng);;
	}
}
//     disabled  enabled
function enableDateField(dateSelectID, bEnable) {
	//bEnable = true: enable, bEnable = false: disable
	if (bEnable) {
		document.getElementById(dateSelectID).disabled = false
	} else {
		document.getElementById(dateSelectID).disabled = true
	}
}
//    disabled  enabled
function isDateFieldEnabled(dateSelectID) {
	//return !document.getElementById(dateSelectID + "_d").disabled
	return !document.getElementById(dateSelectID).disabled
}

//    DMY   MDY
function DateFromDMYToMDY(datestr){
	if (datestr.length==10)
		{return (datestr.substring(3,5)+"."+datestr.substring(0,2)+"."+datestr.substring(6));}
	else {return "";}		
}
//    MDY   DMY
function DateFromMDYToDMY(datestr){
	if (datestr.length==10)
		{return (datestr.substring(3,5)+"."+datestr.substring(0,2)+"."+datestr.substring(6));}
	else {return "";}		
}

//   
function isExists(dateSelectID) {
	if (document.getElementById(dateSelectID)) {
		return true
	} else {
		return false
	}
}


g_fStarted = false
function AnimatePict()
{
	
} // end pgm


var Dict11="";
if(langv==null)
var langv=1
if (langv==1){
    Dict11="    ,    ?";
    }
else{
    Dict11="Can not restore query constructor form, switch to blank constructor form?";
}


<!--
//      
function restoreConstructor() {
	parseQuery(M_sSearchingQuerry);
	var restoredQuery = CreateQuery()
	if (noQueryConstPressed){
	    if (M_sSearchingQuerry != restoredQuery) {
		    resetQueryForm()
		    switchToMode("1");
	    }
	    else {
	    switchToMode("0"); 
	    }
	}
	return true
}
//      
//  ,   
function restoreConstructor_Confirm(){
	parseQuery(M_sSearchingQuerry);
	var restoredQuery = CreateQuery()
	if (noQueryConstPressed){
        if (""=="0") {switchToMode("0")}
        else
        {
		    if (M_sSearchingQuerry != restoredQuery) {
			    if (confirm(Dict11)) {
				    resetQueryForm()
				    switchToMode("1")
			    }else{disableMenuItem(79); enableMenuItem(78);}
		    } else {
			    switchToMode("1")
		    }
	    }
	}
	return true
}





//-->